module Parakeet
  # TODO: Update to 2017 using ActiveSupport::Concern
  module ControllerAddons
    module ClassMethods
      def verify_parameters
        self.send(:before_action, :verify_parameters)
      end

      def guideline
        @guideline ||= ::Guideline.new
      end
    end
    module InstanceMethods
      def check_mixin
        puts "ClassMethod successfully mixed in 12"
      end
      def verify_parameters
        logger.info ActionController::Base.guideline.controller_actions
      end
    end
  end

  if defined? ActionController::Base
    ActionController::Base.extend ControllerAddons::ClassMethods
    ActionController::Base.include ControllerAddons::InstanceMethods
  end
end
